#include <sys/types.h>
#include <sys/stat.h>
#include <signal.h>
#include <stdio.h>
#include <fcntl.h>

void recherche(void);
void attente(void);
void action(int,char *);

int main (void)
{
	struct stat buf;
	time_t temps1;
	long temps2,temps;
	
	while(1)
	{
		if(stat("/usr/mail/meeab99",&buf) != 0)
		{
			printf("erreur avec le stat");
			exit(1);
		}


		temps1=buf.st_mtime;
		temps2=time((long *) 0);
		temps=temps2-temps1;
		
		if ( temps >= 50 )
		{
			printf("Aucun nouveau message\n");
		}
		
		else
		{
			recherche();
		}
	
		attente();
	}

	return 0;
}

void attente(void)
{
	FILE *source,*destination;
	int c;
	
	source=fopen("/usr/mail/meeab99","r");
	if (source==NULL)
	{
		fprintf(stderr,"impossible d ouvrir le fichier\n");
		exit(1);
	}
	
	destination=fopen("meeab99bis","w");
	if (destination==NULL)
	{
		fprintf(stderr,"impossible d ouvrir le fichier\n");
		exit(1);
	}
	
	
	while((c=getc(source))!=EOF)
		putc(c,destination);
	fclose(destination);
	fclose(source);
	
	sleep(30);
	
}

void recherche(void)
{
	int tube[2],n=0,i=0,indicateur=0,avance=0,ind=0;
	char tab[1000],email[50],sub[50];
	pipe(tube);

	for(i=0;i!=1000;i++)
		tab[i]='\0';

	
	if(fork()==0)
	{
		close(1);
		dup (tube[1]);
		close(tube[1]);
		close(tube[0]);
		execlp("./lect_mes","lect_mes",NULL);
	}

	else
	{
		close(tube[1]);
		n=read(tube[0],tab,500);
		tab[n]='\0';
		close(tube[0]);
		wait((int *) 0);
	}


	for(i=0;i!=50;i++)
	{
		email[i]='\0';
		sub[i]='\0';
	}



printf("contenu du fichier :\n%s\n",tab);



	for(n=0;tab[n]!='\0';n++)
	{
		if(tab[n]!='\n')
		{
			if(indicateur==0)
				email[n-avance]=tab[n];
			else
				sub[n-avance]=tab[n];
		}

		else
		{
			if(indicateur==0)
			{
				indicateur=1;
				avance=n+1;
			}

			else
			{
				indicateur=0;
				avance=n+1;


				if(strcmp(sub,"INSCRIPTION")==0)
				{
					action(1,email);
				}
				
				if(strcmp(sub,"ANNULATION")==0)
				{
					action(2,email);
				}
				
				if(strcmp(sub,"AIDE")==0)
				{
					action(3,email);
				}
				if(strcmp(sub,"LISTE")==0)
				{
					action(4,email);
				}
				
				if(strcmp(sub,"INSCRIPTION") && strcmp(sub,"ANNULATION") && strcmp(sub,"AIDE") && strcmp(sub,"LISTE"))
				{
					action(3,email);
				}
					
				for(i=0;i!=50;i++)
				{
					email[i]='\0';
					sub[i]='\0';
				}
			}
		}
	}
}


void action (int ind,char *email)
{

if(fork()==0)
{
	if(ind==1)
	{
		execlp("./ajout","ajout",email,NULL);
	}

	if(ind==2)
	{
		execlp("./enleve","enleve",email,NULL);
	}

	if(ind==3)
	{
		execlp("./aide","aide",email,NULL);
	}

	if(ind==4)
	{
		execlp("./liste","liste",email,NULL);
	}

}
else
{
	wait((int *) 0);
}

}
